---
layout: mockup
title: "Clocks - Stopwatch"
theme: Adwaita/Adwaita.css
permalink: clocks/stopwatch
wallpaper: adwaita
---
<!-- css -->
<link rel="stylesheet" type="text/css" href="{{ site.baseurl }}/css/Adwaita/apps/clocks.css">

{%- include widgets/_panel.html -%}

<!-- Window -->
<div class="window medium">
	<!-- Titlebar -->
	<div id="titlebarClocks" class="titlebar grouped" title="Clocks">
		<!-- left button group -->
		<div class="button-group float-left">
		</div>
		<!-- center button group -->
		<div class="button-group float-center wide hide-on-mobile">
			<div class="view-switcher">
				<a class="" href="{{ site.baseurl }}/clocks/world"><div class="icon s16">{%- include symbolic/maps/globe-symbolic.svg -%}</div><span>World</span></a
				><a class="" href="{{ site.baseurl }}/clocks/alarm"><div class="icon s16">{%- include symbolic/status/alarm-symbolic.svg -%}</div><span>Alarms</span></a
				><a class="active"  href="{{ site.baseurl }}/clocks/stopwatch"><div class="icon s16">{%- include symbolic/apps/stopwatch-symbolic.svg -%}</div><span>Stopwatch</span></a
				><a class="" href="{{ site.baseurl }}/clocks/timer"><div class="icon s16">{%- include symbolic/apps/timer-symbolic.svg -%}</div><span>Timer</span></a>
			</div>
		</div>
		<!-- right button group -->
		<div class="button-group float-right"><a class="button image-button">{%- include symbolic/actions/open-menu-symbolic.svg -%}</a>{%- include components/close-button.html close = "window" -%}
		</div>
	</div>
	<div class="content">
		<div class="view">
			<div class="row text-center">
				<div class="stopwatch">00:00.00</div>
				<div class="controls">
					<a href="#" class="button float-left text-button suggested-action" id="stopwatchStartButton" onClick="stopwatch.start();$(this).hide();$('#stopwatchStopButton').show();$('#stopwatchClearButton').hide();$('#stopwatchLapButton').show();">Start</a>
					<a href="#" class="button float-left text-button destructive-action" id="stopwatchStopButton" onClick="stopwatch.stop();$(this).hide();$('#stopwatchStartButton').show();$('#stopwatchLapButton').hide();$('#stopwatchClearButton').show();">Stop</a>
					<a href="#" class="button float-right text-button" id="stopwatchClearButton" onClick="stopwatch.clear();stopwatch.reset();">Clear</a>
					<a href="#" class="button float-right text-button" id="stopwatchLapButton" onClick="stopwatch.lap();">Lap</a>
					<!-- <a href="#" class="button text-button" id="stopwatchRestartButton" onClick="stopwatch.restart();$('#stopwatchStartButton').hide();$('#stopwatchStopButton').show();">Restart</a> -->
				</div>
			</div>
			<div class="row">
				<ul class="listrow results">
					<li>
						<label><b>02:27.91</b><span class="dim-label"> + </span><span class="info-label">00:38.24</span></label>
						<label class="dim-label float-right">Lap 4</label>
					</li>
					<li>
						<label><b>01:49.67</b><span class="dim-label"> + </span><span class="error-label">00:45.43</span></label>
						<label class="dim-label float-right">Lap 3</label>
					</li>
					<li>
						<label><b>01:04.24</b><span class="dim-label"> + </span><span class="info-label">00:32.13</span></label>
						<label class="dim-label float-right">Lap 2</label>
					</li>
					<li>
						<label><b>00:32.11</b></label>
						<label class="dim-label float-right">Lap 1</label>
					</li>
				</ul>
			</div>
		</div>
	</div>
	<!-- toolbar -->
	<div class="toolbar bottom text-center show-on-mobile">
		<div class="view-switcher">
			<a class="" href="{{ site.baseurl }}/clocks/world"><div class="icon s16">{%- include symbolic/maps/globe-symbolic.svg -%}</div><span>World</span></a
			><a class="" href="{{ site.baseurl }}/clocks/alarm"><div class="icon s16">{%- include symbolic/status/alarm-symbolic.svg -%}</div><span>Alarms</span></a
			><a class="active"  href="{{ site.baseurl }}/clocks/stopwatch"><div class="icon s16">{%- include symbolic/apps/stopwatch-symbolic.svg -%}</div><span>Stopwatch</span></a
			><a class="" href="{{ site.baseurl }}/clocks/timer"><div class="icon s16">{%- include symbolic/apps/timer-symbolic.svg -%}</div><span>Timer</span></a>
		</div>
	</div>
</div>

<script type="text/javascript">
// hide some things
$('#stopwatchLapButton').hide();
$('#stopwatchStopButton').hide();

// make the stopwatch actually work
// source: https://codepen.io/_Billy_Brown/pen/dbJeh
class Stopwatch {

    constructor(display, results) {
        this.running = false;
        this.display = display;
        this.results = results;
        this.laps = [];
        this.reset();
        this.print(this.times);
    }

    reset() {
        this.times = [ 0, 0, 0 ];
    }

    start() {
        if (!this.time) this.time = performance.now();
        if (!this.running) {
            this.running = true;
            requestAnimationFrame(this.step.bind(this));
        }
    }

    lap() {
        let times = this.times;
        let li = document.createElement('li');
        li.innerText = this.format(times);
        this.results.prepend(li);
    }

    stop() {
        this.running = false;
        this.time = null;
    }

    restart() {
        if (!this.time) this.time = performance.now();
        if (!this.running) {
            this.running = true;
            requestAnimationFrame(this.step.bind(this));
        }
        this.reset();
    }

    clear() {
        clearChildren(this.results);
    }

    step(timestamp) {
        if (!this.running) return;
        this.calculate(timestamp);
        this.time = timestamp;
        this.print();
        requestAnimationFrame(this.step.bind(this));
    }

    calculate(timestamp) {
        var diff = timestamp - this.time;
        // Hundredths of a second are 100 ms
        this.times[2] += diff / 10;
        // Seconds are 100 hundredths of a second
        if (this.times[2] >= 100) {
            this.times[1] += 1;
            this.times[2] -= 100;
        }
        // Minutes are 60 seconds
        if (this.times[1] >= 60) {
            this.times[0] += 1;
            this.times[1] -= 60;
        }
    }

    print() {
        this.display.innerText = this.format(this.times);
    }

    format(times) {
        return `${pad0(times[0], 2)}:${pad0(times[1], 2)}.${pad0(Math.floor(times[2]), 2)}`;
    }
}

function pad0(value, count) {
    var result = value.toString();
    for (; result.length < count; --count)
        result = '0' + result;
    return result;
}

function clearChildren(node) {
    while (node.lastChild)
        node.removeChild(node.lastChild);
}

let stopwatch = new Stopwatch(document.querySelector('.stopwatch'),document.querySelector('.results'));
</script>